Attribute VB_Name = "2"
Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0

Public Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type RGB
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
End Type

Public Type RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As RGBQUAD
End Type

Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long
Public Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long

Public Sub FillPallete(Picture As PictureBox, usecolor As RGB)
Dim bi24BitInfo As BITMAPINFO, bBytes() As Byte, Cnt As Long
With bi24BitInfo.bmiHeader
    .biBitCount = 24
    .biCompression = BI_RGB
    .biPlanes = 1
    .biSize = 40
    .biWidth = 256
    .biHeight = 256
End With
ReDim bBytes(1 To bi24BitInfo.bmiHeader.biWidth * bi24BitInfo.bmiHeader.biHeight * 3) As Byte
For xc = 0 To 255
    For yc = 0 To 255
        NewRed = (0 * yc + ((255 * xc + usecolor.rgbRed * (255 - xc)) \ 255) * (255 - yc)) \ 255
        NewGreen = (0 * yc + ((255 * xc + usecolor.rgbGreen * (255 - xc)) \ 255) * (255 - yc)) \ 255
        NewBlue = (0 * yc + ((255 * xc + usecolor.rgbBlue * (255 - xc)) \ 255) * (255 - yc)) \ 255
        GFX_SET_PIXEL_DIB bBytes, xc, yc, RGB(NewRed, NewGreen, NewBlue), bi24BitInfo.bmiHeader.biWidth
    Next yc
Next xc
SetDIBitsToDevice Picture.hdc, 0, 0, bi24BitInfo.bmiHeader.biWidth, bi24BitInfo.bmiHeader.biHeight, 0, 0, 0, bi24BitInfo.bmiHeader.biHeight, bBytes(1), bi24BitInfo, DIB_RGB_COLORS
End Sub

Public Sub GFX_SET_PIXEL_DIB(ByRef obj() As Byte, ByVal sX As Long, ByVal sY As Long, zColor As Long, hWidth As Long)
    Dim dibX As Long, dibY As Long
    Dim cNum As Long
    Dim R As Byte, G As Byte, B As Byte
    
    dibX = sX + 1: dibY = hWidth - sY
    cNum = (hWidth * (dibY - 1) + dibX) * 3 - 2
    R = zColor \ 65536
    G = (zColor And 65535) \ 256
    B = zColor And 255
    
    obj(cNum) = R
    obj(cNum + 2) = B
    obj(cNum + 1) = G
End Sub

Public Function GetRGB(ByVal ColorVal As Long, Result As RGB) As Boolean
    Result.rgbRed = ColorVal And 255
    Result.rgbGreen = (ColorVal And 65535) \ 256
    Result.rgbBlue = ColorVal \ 65536
End Function

Private Sub pic_Spectr_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = vbLeftButton Then
pic_Pallete.Cls
GetRGB GetPixel(pic_Spectr.hdc, X, Y), Color
FillPallete pic_Pallete, Color
txt_Red.Text = Color.rgbRed
txt_Green.Text = Color.rgbGreen
txt_Blue.Text = Color.rgbBlue
End If
End Sub

Private Sub pic_Spectr_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
If Button = vbLeftButton Then
pic_Pallete.Cls
GetRGB GetPixel(pic_Spectr.hdc, X, Y), Color
FillPallete pic_Pallete, Color
txt_Red.Text = Color.rgbRed
txt_Green.Text = Color.rgbGreen
txt_Blue.Text = Color.rgbBlue
End If
End Sub

Public Sub FillSpectre(Picture As PictureBox)
Dim NewRed As Byte
Dim NewGreen As Byte
Dim NewBlue As Byte
Picture.Cls
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, Y - 1, RGB(255, 0, 255 / (42.5 / Y))
    Next Y
Next X
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, 42 + Y - 1, RGB(255 - (255 / (42.5 / Y)), 0, 255)
    Next Y
Next X
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, 84 + Y - 1, RGB(0, 255 / (42.5 / Y), 255)
    Next Y
Next X
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, 126 + Y - 1, RGB(0, 255, 255 - (255 / (42.5 / Y)))
    Next Y
Next X
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, 168 + Y - 1, RGB(255 / (42.5 / Y), 255, 0)
    Next Y
Next X
For X = 1 To 15
    For Y = 1 To 42
        SetPixel Picture.hdc, X - 1, 210 + Y - 1, RGB(255, 255 - (255 / (42.5 / Y)), 0)
    Next Y
Next X
End Sub
